﻿using System;
using System.Collections.Specialized;
using System.Windows.Controls;
using System.Windows.Data;
using Infragistics.Controls.Grids;

namespace GridsCell
{
    public partial class GridView : UserControl
    {
        public GridView()
        {
            InitializeComponent();
            
        }

        private void DeferAddFilterRow()
        {
            if (!DataSource.View.IsEmpty)
            {
                AddFilterRow();
                return;
            }
            DataSource.View.CollectionChanged += DataSourceViewCollectionChanged;
        }

        private void DataSourceViewCollectionChanged(object sender, NotifyCollectionChangedEventArgs e)
        {
            if (!DataSource.View.IsEmpty)
            {
                DataSource.View.CollectionChanged -= DataSourceViewCollectionChanged;
                App.Current.Dispatcher.BeginInvoke(new Action(AddFilterRow));
            }
        }

        private void AddFilterRow()
        {
            grid.FilteringSettings.AllowFiltering = FilterUIType.FilterMenu;
            grid.FilteringSettings.FilteringScope = FilteringScope.ColumnLayout;
        }

        private CollectionViewSource dataSource;
        public CollectionViewSource DataSource
        {
            get { return dataSource; }
            set { 
                dataSource = value;
                var binding = new Binding { Source = value };
                BindingOperations.SetBinding(grid, XamGrid.ItemsSourceProperty, binding);
                DeferAddFilterRow();
            }
        }
    }
}
